"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSJestFeatures = void 0;
const TypeScriptFeatures_cjs_1 = require("./TypeScriptFeatures.cjs");
const TSJestErrorHandler_cjs_1 = require("../Diagnostics/TSJestErrorHandler.cjs");
/**
 * Provides features for `ts-jest` transformations.
 */
class TSJestFeatures extends TypeScriptFeatures_cjs_1.TypeScriptFeatures {
    /**
     * Initializes a new instance of the {@linkcode TSJestFeatures} class.
     *
     * @param compiler
     * The compiler of the plugin.
     *
     * @param config
     * The configuration of the plugin.
     *
     * @param errorHandler
     * A component for reporting errors.
     */
    constructor(compiler, config, errorHandler) {
        super(config, errorHandler);
        this.compiler = compiler;
    }
    /**
     * @inheritdoc
     */
    get TypeScriptFallback() {
        return this.Compiler.configSet.compilerModule;
    }
    /**
     * Gets the compiler of the plugin.
     */
    get Compiler() {
        return this.compiler;
    }
    /**
     * @inheritdoc
     *
     * @returns
     * The newly created error handler
     */
    InitializeErrorHandler() {
        return new TSJestErrorHandler_cjs_1.TSJestErrorHandler(this);
    }
}
exports.TSJestFeatures = TSJestFeatures;
//# sourceMappingURL=TSJestFeatures.cjs.map