"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSPatchFeatures = void 0;
const TypeScriptFeatures_cjs_1 = require("./TypeScriptFeatures.cjs");
const TSPatchErrorHandler_cjs_1 = require("../Diagnostics/TSPatchErrorHandler.cjs");
/**
 * Provides the functionality to handle errors using `ts-patch` components.
 */
class TSPatchFeatures extends TypeScriptFeatures_cjs_1.TypeScriptFeatures {
    /**
     * Initializes a new instance of the {@linkcode TSPatchErrorHandler} class.
     *
     * @param extras
     * A set of tools for interacting with `ts-patch`.
     *
     * @param config
     * The configuration of the plugin.
     *
     * @param errorHandler
     * A component for reporting errors.
     */
    constructor(extras, config, errorHandler) {
        super(config, errorHandler);
        this.extras = extras;
    }
    /**
     * @inheritdoc
     */
    get TypeScript() {
        return this.Extras.ts;
    }
    /**
     * Gets a set of tools for interacting with `ts-patch`.
     */
    get Extras() {
        return this.extras;
    }
    /**
     * @inheritdoc
     *
     * @returns
     * The newly created error handler.
     */
    InitializeErrorHandler() {
        return new TSPatchErrorHandler_cjs_1.TSPatchErrorHandler(this);
    }
}
exports.TSPatchFeatures = TSPatchFeatures;
//# sourceMappingURL=TSPatchFeatures.cjs.map