"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSPatchTransformer = void 0;
const TSPatchFeatures_cjs_1 = require("./TSPatchFeatures.cjs");
const TypeScriptTransformerBase_cjs_1 = require("./TypeScriptTransformerBase.cjs");
/**
 * Provides the functionality to transform typescript nodes using `ts-patch`.
 */
class TSPatchTransformer extends TypeScriptTransformerBase_cjs_1.TypeScriptTransformerBase {
    /**
     * Initializes a new instance of the {@linkcode TSPatchTransformer} class.
     *
     * @param extras
     * A set of tools for interacting with `ts-patch`.
     *
     * @param config
     * The configuration of the plugin.
     *
     * @param errorHandler
     * A component for reporting errors.
     */
    constructor(extras, config, errorHandler) {
        super(new TSPatchFeatures_cjs_1.TSPatchFeatures(extras, config, errorHandler));
    }
}
exports.TSPatchTransformer = TSPatchTransformer;
//# sourceMappingURL=TSPatchTransformer.cjs.map