"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeScriptTransformer = void 0;
const TypeScriptFeatures_cjs_1 = require("./TypeScriptFeatures.cjs");
const TypeScriptTransformerBase_cjs_1 = require("./TypeScriptTransformerBase.cjs");
/**
 * Provides the functionality to transform code using TypeScript.
 *
 * @template TFeatures
 * The type of the features for the transformer.
 */
class TypeScriptTransformer extends TypeScriptTransformerBase_cjs_1.TypeScriptTransformerBase {
    /**
     * Initializes a new instance of the {@linkcode TypeScriptTransformerBase} class.
     *
     * @param config
     * The configuration of the plugin.
     *
     * @param errorHandler
     * A component for reporting errors.
     */
    constructor(config, errorHandler) {
        super(new TypeScriptFeatures_cjs_1.TypeScriptFeatures(config, errorHandler));
    }
}
exports.TypeScriptTransformer = TypeScriptTransformer;
//# sourceMappingURL=TypeScriptTransformer.cjs.map