"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
const common_1 = require("@typescript-nameof/common");
const text = __importStar(require("./text/index.cjs"));
const TSJestTransformer_cjs_1 = require("./Transformation/TSJestTransformer.cjs");
const TSPatchTransformer_cjs_1 = require("./Transformation/TSPatchTransformer.cjs");
const adapter = __importStar(require("./Transformation/TypeScriptAdapter.cjs"));
const vanillaFeatures = __importStar(require("./Transformation/TypeScriptFeatures.cjs"));
const TypeScriptTransformer_cjs_1 = require("./Transformation/TypeScriptTransformer.cjs");
const meta = __importStar(require("./version.cjs"));
/**
 * Creates a `nameof` transformer for the detected ecosystem (vanilla TypeScript or `ts-patch`).
 *
 * @param args
 * The arguments provided by the ecosystem.
 *
 * @returns
 * A transformer for the corresponding ecosystem.
 */
function nameof(...args) {
    var _a;
    let factory;
    if ((_a = args[2]) === null || _a === void 0 ? void 0 : _a.addDiagnostic) {
        // Detecting `ts-patch` (ttypescript's `addDiagnostic` implementation doesn't do anything)
        if (args[2].diagnostics) {
            factory = new TSPatchTransformer_cjs_1.TSPatchTransformer(args[2]).Factory;
        }
        else {
            factory = new TSPatchTransformer_cjs_1.TSPatchTransformer(args[2], undefined, new common_1.ErrorHandler()).Factory;
        }
    }
    else {
        factory = new TypeScriptTransformer_cjs_1.TypeScriptTransformer().Factory;
    }
    if ("factory" in args[0]) {
        return factory(args[0]);
    }
    else {
        return factory;
    }
}
// eslint-disable-next-line @typescript-eslint/no-namespace
(function (nameof) {
    /**
     * The version of the plugin.
     */
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    nameof.version = meta.version;
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    nameof.replaceInFiles = text.replaceInFiles;
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    nameof.replaceInText = text.replaceInText;
    /**
     * Creates a transformer for `ts-jest`.
     *
     * @param compiler
     * The `ts-jest` compiler instance.
     *
     * @returns
     * The newly created {@linkcode TransformerFactory}.
     */
    function factory(compiler) {
        return new TSJestTransformer_cjs_1.TSJestTransformer(compiler).Factory;
    }
    nameof.factory = factory;
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    nameof.TypeScriptAdapter = adapter.TypeScriptAdapter;
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    nameof.TypeScriptFeatures = vanillaFeatures.TypeScriptFeatures;
})(nameof || (nameof = {}));
module.exports = nameof;
//# sourceMappingURL=index.cjs.map